//
//  s95160_s.c	  Segment buffer support
//  Graphic LCD module "SUCCESS ELECTRONIC S95160" I/O library
//  Copyright(C)2013-2014 Toyohiko Togashi tog001@nifty.com
//
//
//  This program is free software; you can redistribute it and/or modify it under the terms of the
//  GNU General Public License as published by the Free Software Foundation; either version 3
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along with this program.
//  If not, see <http://www.gnu.org/licenses/>
//
//
//    Update history
//    ---------- ----- -------------------------------------------
//    2013.12.31 v0.0  First cording
//    2014.01.02 v0.1b Support the Gage, 7segLED figure
//    2014.01.15 v0.1b Support the Bar chart figure
//
#include <stdio.h>
#include "s95160_s.h"

void lcd_segmentNewFigureTable(struct lcd_segmentFigureTable *t){
	switch(t->type){
	case LCD_SEGMENT_TYPE_GROUP:			lcd_segmentNewGroup(t->parent, t->fig);			break;
	case LCD_SEGMENT_TYPE_RECT:				lcd_segmentNewRect(t->parent, t->fig);			break;
	case LCD_SEGMENT_TYPE_POLY:				lcd_segmentNewPoly(t->parent, t->fig);			break;
	case LCD_SEGMENT_TYPE_STR:				lcd_segmentNewStr(t->parent, t->fig);			break;
	case LCD_SEGMENT_TYPE_IMAGE:			lcd_segmentNewImage(t->parent, t->fig);			break;
	case LCD_SEGMENT_TYPE_TEXT:				lcd_segmentNewText(t->parent, t->fig);			break;
	case LCD_SEGMENT_TYPE_GAGE:				lcd_segmentNewGage(t->parent, t->fig);			break;
	case LCD_SEGMENT_TYPE_BARC:				lcd_segmentNewBarChart(t->parent, t->fig);		break;
	case LCD_SEGMENT_TYPE_7SEG:				lcd_segmentNew7seg(t->parent, t->fig);			break;
	case LCD_SEGMENT_TYPE_BUTTON:			lcd_segmentNewButton(t->parent, t->fig);		break;
	case LCD_SEGMENT_TYPE_PULLDOWN:			lcd_segmentNewPullDownField(t->parent, t->fig);	break;
	case LCD_SEGMENT_TYPE_TEXT_FIELD:		lcd_segmentNewTextField(t->parent, t->fig);		break;
	case LCD_SEGMENT_TYPE_INTEGER_FIELD:	lcd_segmentNewIntegerField(t->parent, t->fig);	break;
	case LCD_SEGMENT_TYPE_FLOAT_FIELD:		lcd_segmentNewFloatField(t->parent, t->fig);	break;
	default:	break;
	}
	return;
}

void lcd_segmentNewFigureTables(struct lcd_segmentFigureTable *t, int n){
	int	i;

	for(i = 0; i < n; i++) {
		if (t->type == LCD_SEGMENT_TYPE_END) {
			break;
		}
		lcd_segmentNewFigureTable(t);
		t++;
	}
	return;
}

