//
//  s95160_s.h	  Segment buffer support
//  Graphic LCD module "SUCCESS ELECTRONIC S95160" I/O library
//  Copyright(C)2013-2014 Toyohiko Togashi tog001@nifty.com
//
//
//  This program is free software; you can redistribute it and/or modify it under the terms of the
//  GNU General Public License as published by the Free Software Foundation; either version 3
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along with this program.
//  If not, see <http://www.gnu.org/licenses/>
//
//
//    Update history
//    ---------- ----- -------------------------------------------
//    2013.12.31 v0.0  First cording
//    2014.01.02 v0.1b Support the Gage, 7segLED figure
//    2014.01.04 v0.1b Splitting a source code (s1 -> s1+s2, s2 -> s2+s3)
//    2014.01.15 v0.1b Support the Bar chart figure
//
//		Refer:
//			s95160_s1.h: Layer1 (Primitive segment, horizontal relation)
//			s95160_s2.h: Layer2 (Hierarchy segment, Vertical relation, Touch action)
//			s95160_s3.h: Layer3 (Composite segment)
//
#ifndef S95160_S_H_
#define S95160_S_H_

#include "s95160_s3.h"

// Utility
struct lcd_segmentFigureTable {
	enum lcd_segmentFigureType {
		LCD_SEGMENT_TYPE_GROUP = 0,

		LCD_SEGMENT_TYPE_RECT,
		LCD_SEGMENT_TYPE_POLY,
		LCD_SEGMENT_TYPE_STR,
		LCD_SEGMENT_TYPE_IMAGE,
		LCD_SEGMENT_TYPE_TEXT,
		LCD_SEGMENT_TYPE_GAGE,
		LCD_SEGMENT_TYPE_BARC,
		LCD_SEGMENT_TYPE_7SEG,

		LCD_SEGMENT_TYPE_BUTTON,
		LCD_SEGMENT_TYPE_PULLDOWN,
		LCD_SEGMENT_TYPE_TEXT_FIELD,
		LCD_SEGMENT_TYPE_INTEGER_FIELD,
		LCD_SEGMENT_TYPE_FLOAT_FIELD,

		LCD_SEGMENT_TYPE_END
	}						type;
	void					*parent;
	void					*fig;
};
extern void lcd_segmentNewFigureTable(struct lcd_segmentFigureTable *t);
extern void lcd_segmentNewFigureTables(struct lcd_segmentFigureTable *t, int n);

#endif /* S95160_S_H_ */
