
#include "stm32f4xx_it.h"
#include "stm32f4xx_adc.h"
#include "stm32f4xx_tim.h"
#include "usb_core.h"
#include "usb_hcd_int.h"
#include "usbh_core.h"
#include "usbh_wcc_bluetooth.h"
#include "stm32f4_discovery.h"
#include "rtc.h"
#include "systick.h"
#include <stdio.h>

extern USB_OTG_CORE_HANDLE	USB_OTG_Core;
extern USBH_HOST			USB_Host;
extern void					USB_OTG_BSP_TimerIRQ(void);
extern void					USBH_WCC_Bluetooth_Handle_evt(USB_OTG_CORE_HANDLE *pdev, USBH_HOST *pphost);

void NMI_Handler(void){
}

void HardFault_Handler(void){
	STM_EVAL_LEDOn(LED5);	// Red
	printf("*HardFault*\n");
	for(;;);
}

void MemManage_Handler(void){
	STM_EVAL_LEDOn(LED5);	// Red
	printf("*MemManage*\n");
	for(;;);
}

void BusFault_Handler(void){
	STM_EVAL_LEDOn(LED5);	// Red
	printf("*BusFault*\n");
	for(;;);
}

void UsageFault_Handler(void){
	STM_EVAL_LEDOn(LED5);	// Red
	printf("*UsageFault*\n");
	for(;;);
}

void SVC_Handler(void){
}

void DebugMon_Handler(void){
}

void PendSV_Handler(void){
}

void SysTick_Handler(void){
	SYSTICK_IRQ();
	USBH_WCC_Bluetooth_Handle_evt(&USB_OTG_Core, &USB_Host);
}

void USART2_IRQHandler(void){
}

void ADC_IRQHandler(void) {						// ADC1+DMA: Free run capture
	ADC_ClearITPendingBit(ADC1, ADC_IT_EOC | ADC_IT_JEOC | ADC_IT_AWD | ADC_IT_OVR);
}

void TIM2_IRQHandler(void){						// TIM2: USB
	USB_OTG_BSP_TimerIRQ();
}

void TIM3_IRQHandler(void) {					// TIM3+DMA: Free run capture
    TIM_ClearITPendingBit(TIM3, TIM_IT_Update|TIM_IT_CC1|TIM_IT_CC2|TIM_IT_CC3|TIM_IT_CC1|TIM_IT_COM|TIM_IT_Trigger|TIM_IT_Break);
}

void TIM4_IRQHandler(void) {					// TIM4: RTC
    TIM_ClearITPendingBit(TIM4, TIM_IT_Update|TIM_IT_CC1|TIM_IT_CC2|TIM_IT_CC3|TIM_IT_CC1|TIM_IT_COM|TIM_IT_Trigger|TIM_IT_Break);
	rtc_irq();
}

void OTG_FS_IRQHandler(void){					// USB
	USBH_OTG_ISR_Handler(&USB_OTG_Core);
}

